﻿Imports System.Threading.Tasks
Imports Windows.Phone.Speech.Recognition
Imports System.Windows.Media.Imaging

Partial Public Class PhrasesListGrammar
    Inherits PhoneApplicationPage

    Private recognizer As SpeechRecognizer
    Private _PhraseList() As String = {"topolino", "minni", "paperino", "pluto", "paperina", "pippo"}

    Public Sub New()
        InitializeComponent()
    End Sub

    Private Async Sub PhrasesLIstGrammar_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded
        Await InitializeSpeechRecognizer()
    End Sub

    Private Async Function InitializeSpeechRecognizer() As task
        ' Istanzio l'oggetto da utilizzare per il riconoscimento
        recognizer = New SpeechRecognizer

        ' Imposto il file di grammatica ed eseguo il preloading
        recognizer.Grammars.AddGrammarFromList("phraseList", _PhraseList)

        Await recognizer.PreloadGrammarsAsync()
    End Function

    Private Async Sub RecognitionButton_Click(sender As Object, e As EventArgs)
        ctrListening.Visibility = System.Windows.Visibility.Visible

        Dim result = Await recognizer.RecognizeAsync()
        Dim speechConfidence = SpeechRecognitionConfidence.Low
        If optConfidenceHigh.IsChecked Then
            speechConfidence = SpeechRecognitionConfidence.High
        ElseIf optConfidenceMedium.IsChecked Then
            speechConfidence = SpeechRecognitionConfidence.Medium
        End If

        If result.TextConfidence >= speechConfidence Then
            Me.txtRecognized.Text = String.Format("{0} (RULE={1})", result.Text, result.RuleName)
            Me.imgCharacter.Source = New BitmapImage(New Uri("Assets/WaltDisney/" + result.Text + ".png", UriKind.RelativeOrAbsolute))
        Else
            Me.txtRecognized.Text = "Confidence non sufficiente"
            Me.imgCharacter.Source = Nothing
        End If

        ctrListening.Visibility = System.Windows.Visibility.Collapsed
    End Sub


    Private Sub PhrasesLIstGrammar_Unloaded(sender As Object, e As RoutedEventArgs) Handles Me.Unloaded
        recognizer.Dispose()
    End Sub
End Class
