﻿Imports System
Imports System.Threading
Imports System.Windows.Controls
Imports Microsoft.Phone.Controls
Imports Microsoft.Phone.Shell
Imports Windows.Phone.Speech.Synthesis
Imports Speech.Synthesis

Partial Public Class MainPage
    Inherits PhoneApplicationPage

    Private _synth As SpeechSynthesizer = New SpeechSynthesizer()

    ' Constructor
    Public Sub New()
        InitializeComponent()

        SupportedOrientations = SupportedPageOrientation.Portrait Or SupportedPageOrientation.Landscape

        ' Sample code to localize the ApplicationBar
        'BuildLocalizedApplicationBar()

        Me.lstVoci.ItemsSource = InstalledVoices.All.OrderBy(Function(v) v.Language).ToList()

    End Sub

    ' Sample code for building a localized ApplicationBar
    'Private Sub BuildLocalizedApplicationBar()
    '    ' Set the page's ApplicationBar to a new instance of ApplicationBar.
    '    ApplicationBar = New ApplicationBar()

    '    ' Create a new button and set the text value to the localized string from AppResources.
    '    Dim appBarButton As New ApplicationBarIconButton(New Uri("/Assets/AppBar/appbar.add.rest.png", UriKind.Relative))
    '    appBarButton.Text = AppResources.AppBarButtonText
    '    ApplicationBar.Buttons.Add(appBarButton)

    '    ' Create a new menu item with the localized string from AppResources.
    '    Dim appBarMenuItem As New ApplicationBarMenuItem(AppResources.AppBarMenuItemText)
    '    ApplicationBar.MenuItems.Add(appBarMenuItem)
    'End Sub

    Public Async Sub Speak()
        Dim synth = New SpeechSynthesizer()

        Await synth.SpeakTextAsync("Ciao a tutti!")
    End Sub

    Public Sub SetItalianVoice()
        Dim synth = New SpeechSynthesizer()
        Dim italianVoices = From v In InstalledVoices.All
                          Where v.Language = "it-IT"
                          Select v

        synth.SetVoice(italianVoices.First)
    End Sub

    Private Async Sub PlayButton_Click(sender As Object, e As EventArgs)
        Dim text = Me.txtTesto.Text

        Dim selectedvoices = CType(Me.lstVoci.SelectedItem, VoiceInformation)
        If selectedvoices IsNot Nothing Then
            _synth.SetVoice(selectedvoices)
            Me.txtCurrentVoice.Text = String.Format("{0} [{1}]", selectedvoices.DisplayName, selectedvoices.Gender)
            Await _synth.SpeakTextAsync(text)
            _synth.SetVoice(InstalledVoices.Default)
        End If

    End Sub

    Private Async Sub SSMLButton_Click(sender As Object, e As EventArgs)
        Me.txtCurrentVoice.Text = ""

        Dim ssmlUri = New Uri("ms-appx:///SSML.xml", UriKind.RelativeOrAbsolute)
        AddHandler _synth.BookmarkReached, AddressOf BookmarkReachedHandler
        Await _synth.SpeakSsmlFromUriAsync(ssmlUri)
        RemoveHandler _synth.BookmarkReached, AddressOf BookmarkReachedHandler

        Me.txtCurrentVoice.Text = ""
    End Sub

    Private Sub BookmarkReachedHandler(sender As SpeechSynthesizer, args As SpeechBookmarkReachedEventArgs)
        Dispatcher.BeginInvoke(Sub()
                                   Me.txtCurrentVoice.Text = args.Bookmark
                               End Sub)
    End Sub

End Class